; DrawPoly example -  FastImage ( 1.4x Freeware)
; (c) 2007 Created by MixailV aka Monster^Sage [monster-sage@mail.ru]



Include "include\FastImage.bb"



Graphics3D 800,600,0,2
; initialize FastImage library after Graphics3D with command InitDraw
InitDraw SystemProperty("Direct3DDevice7")



cam=CreateCamera(): CameraClsColor cam,40,40,40 : CreateLight() ;: Musor()



; load textures
tex1=LoadTexture ("media\devil.png",1+2)
tex2=LoadAnimTexture("media\wateranim.jpg", 1+8+256, 124, 124, 0, 23)	



; create images (fast-images) from textures
imgFast1=CreateImageEx(tex1, 256, 256)
imgFast2=CreateImageEx(tex2, 124, 124)



; ! Example functions - how use Bank for create primitives "Poly" !
Function CreateStar (col%=$FFFFFFFF, radiusMax#=100, radiusMin#=50, count%=5)
	bank = CreateBank( 20+(count*2+2)*20 )

	; header info (20 bytes (2 integer value reserved))
	PokeInt		bank,0,count*2+2				;count vertices
	PokeInt		bank,4,FI_NOWRAP				;wrap mode (combine flags: FI_WRAPU, FI_MIRRORU, FI_WRAPV, FI_MIRRORV or use: FI_NOWRAP, FI_WRAPUV, FI_MIRRORUV)
	PokeInt		bank,8,FI_TRIANGLEFAN			;drawing mode (possible values: FI_TRIANGLEFAN, FI_TRIANGLESTRIP, FI_LINESTRIP )
	offset = 20

	; star center vertex (20 bytes per vertex)
	PokeFloat	bank,offset,0					;vertex X
	PokeFloat	bank,offset+4,0					;vertex Y
	PokeInt		bank,offset+8,col-$88000000		;vertex Color $AARRGGBB
	PokeFloat	bank,offset+12,0.5				;vetrex U
	PokeFloat	bank,offset+16,0.5				;vertex V
	offset = offset + 20
	
	; all other vertices (20 bytes per vertex)
	mode=0
	For i=0 To (count*2)
		a#=i*360.0/Float(count*2)-90

		If mode=0
			rad#=radiusMax
		Else
			rad#=radiusMin
		EndIf
		mode=1-mode

		x#=rad*Cos(a)
		y#=rad*Sin(a)

		PokeFloat	bank,offset,x							;vertex X
		PokeFloat	bank,offset+4,y							;vertex Y
		PokeInt		bank,offset+8,col						;vertex Color $AARRGGBB
		PokeFloat	bank,offset+12,0.5+0.5*(x/radiusMax)	;vetrex U
		PokeFloat	bank,offset+16,0.5+0.5*(y/radiusMax)	;vertex V

		offset = offset + 20
	Next

	Return bank
End Function

Function CreateSpiral (col%=$FFFFFFFF, radiusMax#=120, radiusMin#=20)
	count=60
	bank = CreateBank( 20+(count*2)*20 )

	; header info (20 bytes (2 integer value reserved))
	PokeInt		bank,0,count*2					;count vertices
	PokeInt		bank,4,FI_NOWRAP				;wrap mode (combine flags: FI_WRAPU, FI_MIRRORU, FI_WRAPV, FI_MIRRORV or use: FI_NOWRAP, FI_WRAPUV, FI_MIRRORUV)
	PokeInt		bank,8,FI_TRIANGLESTRIP			;drawing mode (possible values: FI_TRIANGLEFAN, FI_TRIANGLESTRIP, FI_LINESTRIP )
	offset = 20

	; all vertices  (20 bytes per vertex)
	For i=0 To count-1
		k#=Float(i/Float(count-1))

		a#=720.0*k-90
		rad#=radiusMin+(radiusMax-radiusMin)*k

		x#=(rad-30*k)*Cos(a)
		y#=(rad-30*k)*Sin(a)
		PokeFloat	bank,offset,x							;vertex X
		PokeFloat	bank,offset+4,y							;vertex Y
		PokeInt		bank,offset+8,col						;vertex Color $AARRGGBB
		PokeFloat	bank,offset+12,0.5+0.5*(x/radiusMax)	;vetrex U
		PokeFloat	bank,offset+16,0.5+0.5*(y/radiusMax)	;vertex V
		offset = offset + 20

		x#=rad*Cos(a)
		y#=rad*Sin(a)
		PokeFloat	bank,offset,x							;vertex X
		PokeFloat	bank,offset+4,y							;vertex Y
		PokeInt		bank,offset+8,col						;vertex Color $AARRGGBB
		PokeFloat	bank,offset+12,0.5+0.5*(x/radiusMax)	;vetrex U
		PokeFloat	bank,offset+16,0.5+0.5*(y/radiusMax)	;vertex V
		offset = offset + 20

		; decrease alpha
		col=col-$04000000
	Next

	Return bank
End Function

Function CreateLineStar (col%=$FFFFFFFF, radiusMax#=100, radiusMin#=50, count%=5)
	bank = CreateBank( 20+(count*2+1)*20 )

	; header info (20 bytes (2 integer value reserved))
	PokeInt		bank,0,count*2+1				;count vertices
	PokeInt		bank,4,FI_NOWRAP				;wrap mode (combine flags: FI_WRAPU, FI_MIRRORU, FI_WRAPV, FI_MIRRORV or use: FI_NOWRAP, FI_WRAPUV, FI_MIRRORUV)
	PokeInt		bank,8,FI_LINESTRIP				;drawing mode (possible values: FI_TRIANGLEFAN, FI_TRIANGLESTRIP, FI_LINESTRIP )
	offset = 20

	; all vertices (20 bytes per vertex)
	mode=0
	For i=0 To (count*2)
		a#=i*360.0/Float(count*2)-90

		If mode=0
			rad#=radiusMax
		Else
			rad#=radiusMin
		EndIf
		mode=1-mode

		x#=rad*Cos(a)
		y#=rad*Sin(a)

		PokeFloat	bank,offset,x							;vertex X
		PokeFloat	bank,offset+4,y							;vertex Y
		PokeInt		bank,offset+8,col						;vertex Color $AARRGGBB
		PokeFloat	bank,offset+12,0.5+0.5*(x/radiusMax)	;vetrex U
		PokeFloat	bank,offset+16,0.5+0.5*(y/radiusMax)	;vertex V
		offset = offset + 20
	Next

	Return bank
End Function


; Create Polys
MyPoly1 = CreateStar($FFFFFFFF, 150, 58, 8)
MyPoly2 = CreateSpiral($FFFFFFFF, 120, 20)
MyPoly3 = CreateLineStar ($FFFFFFFF, 150, 58, 8)


frame = 0 : rotation# = 0
While Not KeyHit (1)
	;MouseLook(cam)
	RenderWorld


	; start drawing with FastImage
	StartDraw
		SetBlend FI_ALPHABLEND
		SetRotation rotation

		; this used for overlay-color
		SetAlpha 0.5
		SetColor 255,255,0

		; draw MyPoly1 (Star)
		DrawPoly 160, 400, MyPoly1
		DrawPoly 400, 400, MyPoly1, 0, 0, FI_COLOROVERLAY							;draw with overlay color
		DrawPoly 600, 400, MyPoly1, imgFast2, (frame Mod 23), FI_COLOROVERLAY		;draw with overlay color

		; draw MyPoly3 (LineStar)
		DrawPoly 160, 260, MyPoly3
		DrawPoly 400, 260, MyPoly3, 0, 0, FI_COLOROVERLAY							;draw with overlay color 
		DrawPoly 600, 260, MyPoly3, imgFast2, (frame Mod 23)						;draw Line-primitive with image (texture)

		; draw MyPoly2 (Spiral)
		DrawPoly 120, 120, MyPoly2, imgFast2, (frame Mod 23)
		DrawPoly 320, 120, MyPoly2, 0, 0, FI_COLOROVERLAY							;draw with overlay color
		DrawPoly 520, 120, MyPoly2

		; draw MyPoly1 at cursor position
		SetRotation 0
		DrawPoly MouseX(), MouseY(), MyPoly1, imgFast1
		
		;end drawing
	EndDraw 


	frame=frame+1 : rotation=rotation+0.5 : Flip
Wend

FreeBank MyPoly1		; free banks with Polys
FreeBank MyPoly2		; ...
FreeBank MyPoly3		; ...


Function MouseLook(cam)
	dx#=(GraphicsWidth()/2-MouseX())*0.01
	dy#=(GraphicsHeight()/2-MouseY())*0.01
	TurnEntity cam,-dy,dx,0
	 If KeyDown(17) MoveEntity cam,0,0,.1 
	 If KeyDown(31) MoveEntity cam,0,0,-.1
	 If KeyDown(32) MoveEntity cam,0.1,0,0 
	 If KeyDown(30) MoveEntity cam,-0.1,0,0 
End Function

Function Musor()
	For i=1 To 50
		cub=CreateCube()
		EntityColor cub,Rand(128,255),Rand(128,255),Rand(128,255)
		PositionEntity cub,Rnd(-10,10),Rnd(-10,10),Rnd(-10,10)
		;EntityAlpha cub,Rnd(0.5,1.0)
		ScaleEntity cub,Rnd(0.3,0.5),Rnd(0.3,0.5),Rnd(0.3,0.5)
		TurnEntity cub,Rnd(0,90),Rnd(0,90),Rnd(0,90)
	Next
End Function