;Example of the FastText library (version 1.x)
;(c) 2007 library created by MixailV aka Monster^Sage [monster-sage@mail.ru]

Include "include\FastText_Unicode.bb"



Graphics3D 800,600,0,2




FileFont0=LoadFont("..\media\memol.ttf",125)			; load font from file
FileFont1=LoadFont("..\media\Selfish.ttf",40)			; ...

UnicodeFont0=LoadFont("Tahoma",25)				; default params = unicode only with Include "include\FastText_Unicode.bb"
UnicodeFont1=LoadFont("Tahoma",15)				; ...

AngleFont0=LoadFont("Tahoma",25, 0,0,0, 45)		; with angle 45 degree
AngleFont1=LoadFont("Tahoma",25, 0,0,0, 68)		; with angle 68 degree
AngleFont2=LoadFont("Tahoma",25, 0,0,0, 90)		; with angle 90 degree

AsciiFont=LoadFont("Tahoma",20, 0,0,0,0, FT_ASCII)	; old Ascii encoded font



CreateLight : Musor : cam=CreateCamera()




While Not KeyHit (1)
	MouseLook(cam) : RenderWorld


	;
	;Font from file example
	;
	Color 255,255,0
	SetFont FileFont0
	
	TextBackground 0,0,128				; SET DarkBlue background for text
	Text 20,0,"Testing Memory Lapses font"	; draw Text with background
	TextBackground 						; background OFF !
	
	Color 255,0,0
	SetFont FileFont1
	Text 20,55,"Test the Selfish font (contains chars with code from 32 before 127 only)"
	
	;
	;Unicode example
	;
	Color 255,255,255
	SetFont UnicodeFont0
	Text 60,100,"Test the Tahoma font (contains multilanguage chars):"
	Text 60,130,"Unicode English - ABCDEFGHIJKabcdefghijk"
	; unicoded text can be seen in any editor that supports the display of unicode(UTF-8) characters
	; such as Notepad (open this source with encoding UTF-8)
	; or new version of IDEal
	Text 60,160,"Unicode Russian - АБВГДЕЖЗИЙабвгдежзий"
	Text 60,190,"Unicode Greek - ΑΒΨΔΕΦΓΗΙΞαβψδεφγηιξκ"
	
	
	Color 96,96,96
	Line 170,240,170,600
	For y=240 To 600 Step 30
		Line 20,y,320,y
	Next

	;
	;Align example
	;
	Color 255,255,0
	SetFont UnicodeFont1
	Text 170,240,"Align Top-Left", FT_LEFT, FT_TOP
	Text 170,270,"Align Top-Centre", FT_CENTER, FT_TOP
	Text 170,300,"Align Top-Right", FT_RIGHT, FT_TOP
	
	Text 170,330,"Align Middle-Left", FT_LEFT, FT_MIDDLE
	Text 170,360,"Align Middle-Centre", FT_CENTER, FT_MIDDLE
	Text 170,390,"Align Middle-Right", FT_RIGHT, FT_MIDDLE
	
	Text 170,420,"Align Bottom-Left", FT_LEFT, FT_BOTTOM
	Text 170,450,"Align Bottom-Centre", FT_CENTER, FT_BOTTOM
	Text 170,480,"Align Bottom-Right", FT_RIGHT, FT_BOTTOM
	
	Text 170,510,"Align Baseline-Left", FT_LEFT, FT_BASELINE
	Text 170,540,"Align Baseline-Centre", FT_CENTER, FT_BASELINE
	Text 170,570,"Align Baseline-Right", FT_RIGHT, FT_BASELINE

	;	
	;Angle example
	;	
	Color 128,128,255
	SetFont AngleFont0
	Text 460,240,"Text with angle 45 degree"
	
	SetFont AngleFont1
	TextBackground 128,0,0				; SET DarkRed background for text
	Text 430,270,"Text with angle 68 degree"
	TextBackground 						; background OFF !
	
	SetFont AngleFont2
	Text 400,300,"Text with angle 90 degree"
	
	;
	;Old Ascii example
	;
	Color 255,0,0
	SetFont AsciiFont
	Text 450,550,"Old Ascii - ABCDEFabcdef Ũ", 0, 0, FT_ASCII
	
	
	Flip
Wend



Function MouseLook(cam)
	dx#=(GraphicsWidth()/2-MouseX())*0.01
	dy#=(GraphicsHeight()/2-MouseY())*0.01
	TurnEntity cam,-dy,dx,0
	 If KeyDown(17) MoveEntity cam,0,0,.1 
	 If KeyDown(31) MoveEntity cam,0,0,-.1
	 If KeyDown(32) MoveEntity cam,0.1,0,0 
	 If KeyDown(30) MoveEntity cam,-0.1,0,0 
End Function

Function Musor()
	For i=1 To 50
		cub=CreateCube()
		EntityColor cub,Rand(128,255),Rand(128,255),Rand(128,255)
		PositionEntity cub,Rnd(-10,10),Rnd(-10,10),Rnd(-10,10)
		;EntityAlpha cub,Rnd(0.5,1.0)
		ScaleEntity cub,Rnd(0.3,0.5),Rnd(0.3,0.5),Rnd(0.3,0.5)
		TurnEntity cub,Rnd(0,90),Rnd(0,90),Rnd(0,90)
	Next
End Function
;~IDEal Editor Parameters:
;~F#5C#66
;~C#Blitz3D198